Bug 979509 - firewall-cmd --direct --get-rules list rules in wrong order
firewall-cmd --direct --get-rules list rules in wrong order
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: firewalld (Show other bugs)
21
Unspecified Linux
unspecified Severity low
: ---
: ---
Assigned To: Thomas Woerner
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-28 13:09 EDT by Edgar Hoch
Modified: 2015-12-02 11:05 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-01 21:48:56 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Edgar Hoch 2013-06-28 13:09:14 EDT
Description of problem:

"firewall-cmd --direct --get-rules ipv4 filter testchain"
lists the rules in the wrong order.
It seems the are ordered lexically instead of priority.

But the rules are applied to netfilter in the right order.
It also seems that firewalld knows interally the correct order, but only the output list is in wrong order.


Version-Release number of selected component (if applicable):
firewalld-0.3.3-2.fc19

How reproducible:
Always.

Steps to Reproduce:
1. Apply these test commands:

firewall-cmd --direct --add-chain ipv4 filter testchain
firewall-cmd --direct --add-rule ipv4 filter testchain 1000 -j RETURN
firewall-cmd --direct --add-rule ipv4 filter testchain 0 -s 192.0.2.10 -j DROP
firewall-cmd --direct --add-rule ipv4 filter testchain 0 -s 192.0.2.11 -j DROP

2. Before, between, and after each of the commands above you may apply the following command to see the current state of firewalld and netfilter rules:

firewall-cmd --direct --get-rules ipv4 filter testchain
iptables -v -L testchain
iptables -S testchain

3. Apply the following command
(to get the output for the actual and the expected result):

firewall-cmd --direct --get-rules ipv4 filter testchain


Actual results:

-j RETURN
-s 192.0.2.10 -j DROP
-s 192.0.2.11 -j DROP

Expected results:

-s 192.0.2.10 -j DROP
-s 192.0.2.11 -j DROP
-j RETURN


Additional info:

The output of "iptables -v -L testchain" is:

Chain testchain (0 references)
 pkts bytes target     prot opt in     out     source               destination         
    0     0 DROP       all  --  any    any     192.0.2.10           anywhere            
    0     0 DROP       all  --  any    any     192.0.2.11           anywhere            
    0     0 RETURN     all  --  any    any     anywhere             anywhere            


The output of "iptables -S testchain" is:

-N testchain
-A testchain -s 192.0.2.10/32 -j DROP
-A testchain -s 192.0.2.11/32 -j DROP
-A testchain -j RETURN


Both are correct.
Comment 1 Fedora Update System 2013-07-30 15:13:54 EDT
firewalld-0.3.4-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/firewalld-0.3.4-1.fc19
Comment 2 Fedora Update System 2013-08-01 23:48:46 EDT
Package firewalld-0.3.4-1.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing firewalld-0.3.4-1.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-14046/firewalld-0.3.4-1.fc19
then log in and leave karma (feedback).
Comment 3 Fedora Update System 2013-08-03 20:09:22 EDT
firewalld-0.3.4-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 4 Edgar Hoch 2013-08-27 12:57:47 EDT
I have checked my test example now (sorry for the delay).
If found that the error is not fixed.

With firewalld-0.3.4-1.fc19 installed, I get the following result of step 3 of "Steps to Reproduce":

1000 -j RETURN
0 -s 192.0.2.10 -j DROP
0 -s 192.0.2.11 -j DROP

The result is different from that of my first report, because now the priority is shown in the first column of the result. But the output is not sorted by the priority, it is still in wrong order.
Comment 5 Fedora End Of Life 2015-01-09 17:10:22 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 6 Fedora End Of Life 2015-11-04 10:44:08 EST
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2015-12-01 21:48:59 EST
Fedora 21 changed to end-of-life (EOL) status on 2015-12-01. Fedora 21 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.